c simplx:  simplex minimization subroutine.
c minmax:  called by subroutine simplx.
c first:             "
c centor:            "
c newsim:            "
c update:            "
c reduce:            "
c epslon:            "
c
c define parameter.
c maxh:    max dimension of vector x.
c
c procedure to use this program.
c 1. save this mail to a file. (save file-name.f)
c 2. delete the comments. (vi file name.f)
c 3. change the define parameter and function.
c
c program starts. ------------------------------------------------------
c
      implicit real * 8 (a-h,o-z)
      parameter   (maxh=6, maxh5=maxh+5)
c
      common/paramscl/sclp,sclc,sclnu,sclmu
      common /fnmin/ fmin
      common / sizes / tx,ty
      common /skip/iskip
      common /fname/filea
      common/interval/x2
      character*50 filea
      real*8 sclp,sclc,sclnu,sclmu
      integer    n
      real*8     xinit(maxh), dist, eps, f
      external   funct
      fmin=1.d10
***************************
      open(13, file='IP.param')
      read(13,*) ix,iy,iz,iskip
      tx=1.0d0
      read(13,*) ty
      read(13,*) sclmu, sclnu, sclp, sclc
      read(13,1) filea
      read(13,*) x2
    1 format(a)
***************************
      call input
      n = 4
      if(iskip.eq.1) open(8, FILE='IP.simplex.print')
      if(iskip.eq.1000) open(8, FILE='IP1000.simplex.print')
c     write(8,*) '                 -log L           p             c  ',
c    &'           mu            nu'
      write(8,*) '           -log L                 mu            nu ',
     &'           p             c'
      close(8)
      xinit(1) = 1.0d0
      xinit(2) = 1.0d0
      xinit(3) = 1.0d0
      xinit(4) = 1.0d0
c
      dist = 0.1d0
      eps = 1.0d-3
c
      call simplx(xinit, n, funct, dist, eps, f)
c
      stop
      end
c -------------------------------------------------------------------- c
      subroutine input
      implicit real * 8 (a-h,o-z)
      common/datpar/ nn
      common/xyod/rr(9234567),th(9234567)
      common/ddd/ff,aic
      common/range/rmin,rmax
      common / sizes / tx,ty
      dimension x(15000),y(15000)
      DATA PI /3.14159265358979D0/
c correlation lag band (Palm intensity)
      rmin=0.0d0
      rmax=0.5d0
      t1=rmax
      CALL inlvy(X,Y,N,TX,TY,T1)
c periodic boundary
      NN=0
      DO 10 I=1,N
      DO 20 J=1,N
      if(J.eq.I) go to 20
      XX=X(J)-X(I)
      IF(XX.GT.TX/2) XX=-(TX-XX)
      IF(XX.LT.-TX/2) XX=(TX+XX)
      YY=Y(J)-Y(I)
      IF(YY.GT.TY/2) YY=-(TY-YY)
      IF(YY.LT.-TY/2) YY=(TY+YY)
      IF(ABS(XX).GT.T1.OR.ABS(YY).GT.T1) GO TO 20
      R2=SQRT(XX**2+YY**2)
      IF(R2.GT.T1) GO TO 20
      NN=NN+1
      IF(NN.GT.9234567) STOP 229
      RR(NN)=R2
   20 CONTINUE
   10 CONTINUE
      write(*,*) 'NN=', nn
c     prob=500**2*(0.5**2-0.1**2)*3.14159265
      write(6,1) 'nn,rmin,rmax ',nn,rmin,rmax
    1 format(1h ,a,1x,i10,3f15.5)
      return
      end
      subroutine INLVY(X,Y,N,TX,TY,T1)
      implicit real * 8 (a-h,o-z)
      dimension x(15000),y(15000)
      common/events/np
      common /fname/filea
      character*50 filea
      open(1,file=filea)
c
      I=1
 10   read(1, *, end=30) X(I), Y(I) 
	  I=I+1
	  go to 10
 30   continue
      n=i-1
      np=n
      return
      end
c -------------------------------------------------------------------- c
      subroutine funct(n,b,fn)
c-----------------------------------------------------------------------
c     likelihood function of the inverse power poisson process
c-----------------------------------------------------------------------
      implicit real * 8 (a-h,o-z)
      common/datpar/ nn
      common/xyod/rr(9234567),th(9234567)
      common/ddd/ff,aic
      common/range/rmin,rmax
      common/paramscl/sclp,sclc,sclnu,sclmu
      common/param/ap,ac
      common/events/np
      common /fnmin/ fmin
      common /skip/iskip
c
      data pi/3.14159265358979d0/
      dimension b(4),g(4),h(4)
      pi=3.14159265358979d0
      ap=b(1)**2 *sclp
      ac=b(2)**2 *sclc
      anu=b(3)**2 *sclnu
      amu=b(4)**2 *sclmu
c
      f1=0.0
      do 30 i=1,nn,iskip
c     if(mod(i,10000).eq.0) write(6,*) 'i=',i, '/',nn
      if(rr(i).le.rmin.or.rr(i).ge.rmax) go to 30
c
      call power(rr(i),dFr,Frmax)
      ramdai=(amu*anu)+anu/2/pi/rr(i)*dFr
c
      if(ramdai.le.0.0) go to 190
      f1=f1+log(ramdai)
   30 continue
c
      rmax=1.0d0/2
      call power(rmax,dFr,Frmax)
c
      aKrmax=pi*(rmax**2)+anu*Frmax/(amu*anu)
c
      fn=iskip*f1-(amu*anu)*aKrmax*np
      fn=-fn
      if(fmin.gt.fn) then
      fmin=fn
      ipri=1
      else
      ipri=0
      end if
      if(iskip.eq.1) open(8,FILE='IP.simplex.print',position='APPEND')
      if(iskip.eq.1000) 
     & open(8,FILE='IP1000.simplex.print',position='APPEND')
c     if(ipri.eq.0) write(8,2) 'testfn =',fn,ap,ac,amu,anu
c     if(ipri.eq.1) write(8,2) 'update =',fn,ap,ac,amu,anu
      if(ipri.eq.0) write(8,2) 'testfn =',fn,amu,anu,ap,ac
      if(ipri.eq.1) write(8,2) 'update =',fn,amu,anu,ap,ac
      close(8)
    3 format(1h ,110x,d18.10)
    1 format(1h ,7d18.10)
    2 format(1h , a, d23.15,4d14.7)
      return
  190 continue
      fn=1.d30
      write(6,2) 'fn190 =',fn,ap,ac,anu,amu
      return
      end
c
c -------------------------------------------------------------------- c
      subroutine simplx(xinit, n, funct, dist, eps, fr)
c -------------------------------------------------------------------- c
c -- parameter: ------------------------------------------------------ c
c ---- i/o xinit:      vector of initial and final x ----------------- c
c ---- i   n:          dimension of the vector x --------------------- c
c ---- i   funct:      minimize function ----------------------------- c
c ---- i   dist:       size of first simplex ------------------------- c
c ---- i   eps:        epsilon --------------------------------------- c
c ---- o   fr:         final value ----------------------------------- c
c -------------------------------------------------------------------- c
c -- this subroutine call next subroutine and function. -------------  c
c --------- first, minmax, newsim, center, reduce, update, epslon ---- c
c -------------------------------------------------------------------- c
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      external   funct
c
      integer    n
      real*8     xinit(maxh), dist, eps, fr
c
      integer    iter, xh, xs, xl, x0, xr, xe, xc, j
      real*8     f(maxh5), x(maxh5,maxh)
      real*8     epslon
      real*8     eps1, alpha, beta, gamma
c
      data       alpha/-1.0d0/, beta/0.5d0/, gamma/2.0d0/
c
      x0 = n + 2
      xr = n + 3
      xe = n + 4
      xc = n + 5
c
      call first(n, f, x, funct, xinit, dist)
c -------------------------------------------------------------------- c
      write(6,*)
      write(6,*) '   #    -log L     standard error  x(1)        x(2)',
     &'        x(3)        x(4)'
      iter = 0
c
c                                                ****   main loop   ****
1     continue
c
c                                           ****   min max search   ****
      call minmax(n, f, xh, xs, xl)
c
c                                            ****   epsilon check   ****
      eps1 = epslon(n, f)
c
c     write(6,31) iter, f(xl), eps1,(x(xl,i), i=1, n)
      write(6,31) iter, f(xl), eps1,(x(xl,i), i=3, n),(x(xl,i), i=1, 2)
   31 format(i5, f15.3, 5d12.4)
      if(iter .gt. 2 .and. eps1 .lt. eps) go to 2
c
c                                               ****   center set   ****
      call center(n, x, xh, x0)
c
c                                               ****   reflection   ****
      call newsim(n, f, x, funct, x0, xh, alpha, xr)
c
      if(f(xr) .le. f(xs)) then
c
        if(f(xr) .lt. f(xl)) then
c
c                                                ****   expansion   ****
          call newsim(n, f, x, funct, x0, xr, gamma, xe)
c
          if(f(xe) .lt. f(xr)) then
            call update(n, f, x, xe, xh)
          else
            call update(n, f, x, xr, xh)
            end if
c
        else
          call update(n, f, x, xr, xh)
          end if
c
      else
c
        if(f(xr) .lt. f(xh)) call update(n, f, x, xr, xh)
c
c                                              ****   contraction   ****
        call newsim(n, f, x, funct, x0, xh, beta, xc)
c
        if(f(xc) .lt. f(xh)) then
          call update(n, f, x, xc, xh)
c
        else
c
c                                                   ****   reduce   ****
          call reduce(n, f, x, funct, xl)
c
          end if
c
        end if
c
      iter = iter + 1
c
      if(iter .gt. 1000 ) go to 2
c
c                                            ****   epsilon check   ****
      go to 1
c
2     continue
c
      do 10 j = 1, n
        xinit(j) = x(xl, j)
10      continue
      fr = f(xl)
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine minmax(n, f, xh, xs, xl)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      integer    n, xh, xs, xl
      real*8     f(maxh5)
c
      integer    i
      real*8     fmin1, fmax1, fmax2
c
      if(f(1) .gt. f(2)) then
        fmax1 = f(1)
        xh = 1
        fmax2 = f(2)
        xs = 2
        fmin1 = f(2)
        xl = 2
      else
        fmax1 = f(2)
        xh = 2
        fmax2 = f(1)
        xs = 1
        fmin1 = f(1)
        xl = 1
        end if
c
      do 10 i = 3, n+1
c
        if(f(i) .gt. fmax1) then
          fmax2 = fmax1
          xs = xh
          fmax1 = f(i)
          xh = i
c
        else if(f(i) .gt. fmax2) then
          fmax2 = f(i)
          xs = i
          end if
c
        if(f(i) .lt. fmin1) then
          fmin1 = f(i)
          xl = i
          end if
c
10      continue
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine first(n, f, x, funct, xinit, dist)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      external   funct
c
      integer    n
      real*8     f(maxh5), x(maxh5,maxh), xinit(maxh), xx(maxh), dist
c
      integer    i, j
c
      do 10 i = 1, n + 1
c
        do 20 j = 1, n
          x(i,j) = xinit(j)
          xx(j) = x(i,j)
20        continue
c
        if(i .ne. 1 ) then
          x(i,i-1) = x(i,i-1) + dist
          xx(i-1) = x(i,i-1)
          end if
c
c       write(6,*) 'test-first',i
        call funct(n, xx, f(i))
c
10      continue
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine center(n, x, xh, x0)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      integer    n, xh, x0
      real*8     x(maxh5,maxh)
c
      integer    i, j
c
      do 10 j = 1, n
        x(x0,j) = 0.0d0
        do 20 i = 1, n+1
          if(i .ne. xh) x(x0,j) = x(x0,j) + x(i,j)
20        continue
        x(x0,j) = x(x0,j) / dfloat(n)
10      continue
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      function   epslon(n, f)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      integer    n
      real*8     f(maxh5)
c
      integer    i
      real*8     epslon, emean
c
      emean = 0.0d0
      do 10 i = 1, n+1
        emean = emean + f(i)
10      continue
      emean = emean / dfloat(n+1)
c
      epslon = 0.0d0
      do 20 i = 1, n+1
        epslon = epslon + (f(i) - emean) ** 2
20      continue
      epslon = dsqrt(epslon) / dfloat(n+1)
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine newsim(n, f, x, funct, x0, in, prm, out)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      external   funct
c
      integer    n, x0, in, out
      real*8     f(maxh5), x(maxh5,maxh), xx(maxh), prm
c
      integer    j
c
      do 10 j = 1, n
        x(out,j) = prm * x(in,j) + (1.0 - prm) * x(x0,j)
        xx(j) = x(out,j)
10      continue
      call funct(n, xx, f(out))
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine update(n, f, x, in, out)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      integer    n, in, out
      real*8     f(maxh5), x(maxh5,maxh)
c
      integer    j
c
      do 10 j = 1 , n
        x(out,j) = x(in,j)
10      continue
c
      f(out) = f(in)
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine reduce(n, f, x, funct, xl)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      external   funct
c
      integer    n, xl
      real*8     f(maxh5), x(maxh5,maxh), xx(maxh)
c
      integer    i, j
c
      do 10 i = 1, n+1
        if(i .ne. xl) then
          do 20 j = 1, n
            x(i,j) = (x(i,j) + x(xl,j)) / 2.0d0
            xx(j) = x(i,j)
20          continue
c
          call funct(n, xx, f(i))
          end if
10      continue
c
      return
      end
c--------------------------------------------------------------------- c
c--------------------------------------------------------------------- c
      subroutine power(ri,dFr,Fr)
c
      implicit real*8(a-h,o-z)
C     driver for routine qgaus
      common/distance/r0
      common/case/kk
      common/param/ap,ac
      common/interval/x2
      INTEGER NVAL
c      REAL X1,X2
c      PARAMETER(X1=r0/2,X2=1.0,NVAL=10)
      INTEGER i
c      REAL dx,func,ss,x
      EXTERNAL func
c
      r0=ri
c
   10 continue
c      write(6,*) 'input r0'
c      read(5,*) r0
c     write(6,*) 'input x2'
c     read(5,*) x2    
c     x2=0.3d0
      delta=0.001d0
c     open(1, FILE='power.plot.txt')
c     open(2, FILE='power.plot.eps0.txt')
c----------------------------------------------------------
c      do 15 j=1, 500
c     r0=delta*j
      x1=r0/2
      nval=100
        kk=1
        call quad2d(X1,X2,ss)
        kk=2
        call quad2d(0.0d0,x1,tt)
        kk=3
        call quad2d(0.0d0,x1,uu)
c        write(6,*) 'r=', r0
c        write(6,*) 'integral=', x1, x2, ss, tt, uu
c        write(6,*) 'F(r)=', 2*(ss+tt+uu)
11    continue
      Fr=2*(ss+tt+uu)
c----------------------------------------------------------
      eps=0.001d0
*     r0=delta*j+eps
      r0=ri+eps
      x1=r0/2
      nval=100
        kk=1
        call quad2d(X1,X2,ss)
        kk=2
        call quad2d(0.0d0,x1,tt)
        kk=3
        call quad2d(0.0d0,x1,uu)
c        write(6,*) 'r=', r0
c        write(6,*) 'integral=', x1, x2, ss, tt, uu
c        write(6,*) 'F(r)=', 2*(ss+tt+uu)
      Freps1=2*(ss+tt+uu)
c----------------------------------------------------------
*     r0=delta*j-eps
      r0=ri-eps
      x1=r0/2
      nval=100
        kk=1
        call quad2d(X1,X2,ss)
        kk=2
        call quad2d(0.0d0,x1,tt)
        kk=3
        call quad2d(0.0d0,x1,uu)
c        write(6,*) 'r=', r0
c        write(6,*) 'integral=', x1, x2, ss, tt, uu
c        write(6,*) 'F(r)=', 2*(ss+tt+uu)
      Freps2=2*(ss+tt+uu)
      if (r0.eq.0) then
      Freps2=0
      end if   
      dFr=(Freps1-Freps2)/(2*eps)
c     if(ap.gt.1.6) then
c     write(6,*) 'kkkk', dFr,Fr,Freps1,Freps2,ap,ri
c     endif
      pi=3.14159265358979d0
*     nu=30
*     mu=1500
*     nu:the mean number of points per cluster
*     r.v. the number of points per cluster which is Poisson distributed  
*     aKr:Ripley's K-function
*     mu*aKr=mu*pi*(r**2)+nu*Fr
c     aKr=pi*(r**2)+nu*Fr/mu
c     daKr=2*pi*r+nu*dFr/mu
c     Palm intensity:alambda
c     alambda=mu*dKr/(2*pi*r) 
c     write(1,*) delta*j, Fr
c     write(2,*) delta*j, dFr 
c      write(6,*) delta*j, dFr
c15    continue
c      go to 10
c     close(1)
c     close(2)
      return
      END

      SUBROUTINE quad2d(x1,x2,ss)
      implicit real*8(a-h,o-z)
      common/distance/r0
c      REAL ss,x1,x2,h
      EXTERNAL h
CU    USES h,qgausx
      call qgausx(h,x1,x2,ss)
      return
      END

      real*8 FUNCTION f(yy)
      implicit real*8(a-h,o-z)
      common/distance/r0
c      REAL f,yy,func,x,y,z
      COMMON /xyz/ x,y,z
CU    USES func
      y=yy
      f=func(x,y)
      return
      END

      real*8 FUNCTION h(xx)
      implicit real*8(a-h,o-z)
      common/distance/r0
      common/case/kk 
c      REAL h,xx,func,y1,y2,x,y,z
      EXTERNAL func
      COMMON /xyz/ x,y,z
CU    USES g,qgausy,y1,y2
c      REAL ss
      x=xx
      if (kk.eq.1) call qgausy(func,y1(x),y2(x),ss)
      if (kk.eq.2) call qgausy(func,y3(x),y2(x),ss)
      if (kk.eq.3) call qgausy(func,y1(x),y3(x),ss)
c      write(6,*) kk, ss,y1(x),y2(x),y3(x)
      h=ss
      return
      END

      SUBROUTINE qgausx(func,a,b,ss)
      implicit real*8(a-h,o-z)
      common/distance/r0
c      REAL a,b,ss,func
      EXTERNAL func
      INTEGER j
c      REAL dx,xm,xr,w(5),x(5)
      dimension w(5), x(5)
      SAVE w,x
      DATA w/.2955242247d0,.2692667193d0,.2190863625d0,.1494513491d0,
     *.0666713443d0/
      DATA x/.1488743389d0,.4333953941d0,.6794095682d0,.8650633666d0,
     *.9739065285d0/
      xm=0.5d0*(b+a)
      xr=0.5d0*(b-a)
      ss=0
      do 11 j=1,5
        dx=xr*x(j)
        ss=ss+w(j)*(func(xm+dx)+func(xm-dx))
11    continue
      ss=xr*ss
      return
      END

      SUBROUTINE qgausy(func,a,b,ss)
      implicit real*8(a-h,o-z)
      common/distance/r0
c      REAL a,b,ss,func
      EXTERNAL func
      INTEGER j
c      REAL dx,xm,xr,w(5),x(5)
      dimension w(5), x(5)
      SAVE w,x
      DATA w/.2955242247d0,.2692667193d0,.2190863625d0,.1494513491d0,
     *.0666713443d0/
      DATA x/.1488743389d0,.4333953941d0,.6794095682d0,.8650633666d0,
     *.9739065285d0/
      xm=0.5d0*(b+a)
      xr=0.5d0*(b-a)
      ss=0
      do 11 j=1,5
        dx=xr*x(j)
        ss=ss+w(j)*(f(xm+dx)+f(xm-dx))
11    continue
      ss=xr*ss
      return
      END

      real*8 FUNCTION func(x,y)
      implicit real*8(a-h,o-z)
      common/distance/r0
      common/case/kk
c      common/param/p,c
      common/param/ap,ac
c      REAL x,y
      pi=3.14159265358979d0
c     p=1.5d0
c     c=0.005d0
      ak=(ap-1)*(ac**(ap-1)) 
      if (kk.le.2) func=(1/pi)*acos((x**2+y**2-(r0)**2)/(2*x*y))
     &     *(ak/(x+ac)**ap)
     &     *(ak/(y+ac)**ap)
      if (kk.eq.3) func=1
     &                  *(ak/(x+ac)**ap)
     &                  *(ak/(y+ac)**ap)
c      write(6,*) func,x,y
      return
      END

      real*8 FUNCTION y1(x)
      implicit real*8(a-h,o-z)
      common/distance/r0
c      REAL x,y
      y1=x
      return
      END

      real*8 FUNCTION y2(x)
      implicit real*8(a-h,o-z)
      common/distance/r0
c      REAL x,y
      y2=x+r0
      return
      END

      real*8 FUNCTION y3(x)
      implicit real*8(a-h,o-z)
      common/distance/r0
c      REAL x,y
      y3=-x+r0
      return
      END

