c simplx:  simplex minimization subroutine.
c minmax:  called by subroutine simplx.
c first:             "
c centor:            "
c newsim:            "
c update:            "
c reduce:            "
c epslon:            "
c
c define parameter.
c maxh:    max dimension of vector x.
c
c procedure to use this program.
c 1. save this mail to a file. (save file-name.f)
c 2. delete the comments. (vi file name.f)
c 3. change the define parameter and function.
c
c program starts. ------------------------------------------------------
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      implicit real * 8 (a-h,o-z)
      common/paramscl/scllam,scla,sclnu1,sclnu2,scls1,scls2
      common /fnmin/ fmin
      common / sizes / tx,ty
      common /fname/filea
      character*50 filea
      real*8 scllam,scla,sclnu1,sclnu2,scls1,scls2
      integer    n
      real*8     xinit(maxh), dist, eps, f
      external   funct
      fmin=1.d10
***************************
      open(13, file='TypeC.param')
      read(13,*) 
      tx=1.0d0
      read(13,*) ty
      read(13,*) amu1,amu2,anu1,anu2,scls1,scls2
c
      scllam = amu1*anu1+amu2*anu2
      scla = amu1*anu1/scllam
      sclnu1=anu1
      read(13,1) filea
    1 format(a)
***************************
      call input
c
      n = 5
c    
      open(8, FILE='TypeC.simplex.print')
      write(8,2) '            -log L            lambda      nu1',
     &'         a           s1          s2'
    2 format(2a)
      xinit(1) = 1.0d0
      xinit(2) = 1.0d0
      xinit(3) = 1.0d0
      xinit(4) = 1.0d0
      xinit(5) = 1.0d0
c
      dist = 0.1d0
      eps = 1.0d-3

c
      call simplx(xinit, n, funct, dist, eps, f)
c
      stop
      end
c -------------------------------------------------------------------- c
      subroutine input
      implicit real * 8 (a-h,o-z)
      common/datpar/ nn
      common/xyod/rr(9234567),th(9234567)
      common/ddd/ff,aic
      common/range/rmin,rmax
      common / sizes / tx,ty
      dimension x(15000),y(15000), u(15000), v(15000)
      DATA PI /3.14159265358979D0/
c correlation lag band (Palm intensity)
      rmin=0.0d0
      rmax=1.d0/2
      t1=rmax
      CALL inlvy(X,Y,N,TX,TY,T1,u,v)
c periodic boundary
      NN=0
      DO 10 I=1,N
      DO 20 J=1,N
      if(J.eq.I) go to 20
      XX=X(J)-X(I)
      IF(XX.GT.TX/2) XX=-(TX-XX)
      IF(XX.LT.-TX/2) XX=(TX+XX)
      YY=Y(J)-Y(I)
      IF(YY.GT.TY/2) YY=-(TY-YY)
      IF(YY.LT.-TY/2) YY=(TY+YY)
      IF(ABS(XX).GT.T1.OR.ABS(YY).GT.T1) GO TO 20
      R2=SQRT(XX**2+YY**2)
      IF(R2.GT.T1) GO TO 20
      NN=NN+1
      IF(NN.GT.9234567) STOP 229
      RR(NN)=R2
   20 CONTINUE
   10 CONTINUE
      write(6,*) 'NN=', nn
c     prob=500**2*(0.5**2-0.1**2)*3.14159265
      write(6,1) 'nn,rmin,rmax ',nn,rmin,rmax
    1 format(1h ,a,1x,i10,3f15.5)
      return
      end
      subroutine INLVY(X,Y,N,TX,TY,T1,u,v)
      implicit real * 8 (a-h,o-z)
      dimension x(5000),y(5000)
      common/events/np
      common /fname/filea
      character*50 filea
      open(1,file=filea)
c
      I=1
 10   read(1, *, end=30) X(I), Y(I)
          I=I+1
          go to 10
 30   continue
      n=i-1
      np=n
c
      return
      end
      subroutine funct(n,b,fn)
c-----------------------------------------------------------------------
c     likelihood function of the inverse power poisson process
c-----------------------------------------------------------------------
      implicit real * 8 (a-h,o-z)
      common/datpar/ nn
      common/xyod/rr(9234567),th(9234567)
      common/ddd/ff,aic
      common/range/rmin,rmax
      common/paramscl/scllam,scla,sclnu1,sclnu2,scls1,scls2
      common/events/np
      common /fnmin/ fmin
      data pi/3.14159265358979d0/
      dimension b(6),g(6),h(6)
      pi=3.14159265358979d0
      eps=0.1d-5
      alam=b(1)**2 * scllam
      a=b(2)**2 * scla
      anu1=b(3)**2 * sclnu1
      s1=b(4)**2 * scls1
      s2=b(5)**2 * scls2 
      anu2=anu1 * s2/s1
      se=s2-eps
      f1=0.0
      do 30 i=1,nn
      if(rr(i).le.rmin.or.rr(i).ge.rmax) go to 30
      exp1i = exp(-((rr(i))**2)/(4*((s1)**2)))
      exp2i = exp(-((rr(i))**2)/(4*((s2)**2)))
      exp1rmax = 2*((s1)**2)*(1 - exp(-(rmax**2)/(4*((s1)**2))))
      exp2rmax = 2*((s2)**2)*(1 - exp(-(rmax**2)/(4*((s2)**2))))
      ramdai = (alam) + (a)*
     &         (1/((s1)**2))*(anu1/(4*pi))*exp1i+
     &         (1-a)*(1/((s2)**2))*(anu2/(4*pi))*
     &         exp2i       
      if(ramdai.le.0.0) go to 190
      f1=f1+log(ramdai)
   30 continue
       fs1 = pi*(rmax**2)*(alam)
      ainteg1 = 2*pi*(a)*
     &          (1/((s1)**2))*(anu1/(4*pi))*exp1rmax
      ainteg2 = 2*pi*(1-a)*
     &          (1/((s2)**2))*(anu2/(4*pi))*exp2rmax
      fn=f1-(fs1+ainteg1+ainteg2)*np
      fn=-fn
      ff=fn
      if(fmin.gt.fn) then
      fmin=fn
      ipri=1
      else
      ipri=0
      end if
      open(8, FILE='TypeC.simplex.print',position='APPEND')
      if(ipri.eq.0) write(8,2) 'testfn =',fn,alam,anu1,a,s1,s2
      if(ipri.eq.1) write(8,2) 'update =',fn,alam,anu1,a,s1,s2
      close(8)
      return
      write(6,*) 'h(6)=', h(6)
    3 format(1h ,110x,d18.10)
    2 format(1h , a, d18.10,6d12.5)
    1 format(1h ,7d18.10)
c
  190 continue
      fn=1.0d30
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine simplx(xinit, n, funct, dist, eps, fr)
c -------------------------------------------------------------------- c
c -- parameter: ------------------------------------------------------ c
c ---- i/o xinit:      vector of initial and final x ----------------- c
c ---- i   n:          dimension of the vector x --------------------- c
c ---- i   funct:      minimize function ----------------------------- c
c ---- i   dist:       size of first simplex ------------------------- c
c ---- i   eps:        epsilon --------------------------------------- c
c ---- o   fr:         final value ----------------------------------- c
c -------------------------------------------------------------------- c
c -- this subroutine call next subroutine and function. -------------  c
c --------- first, minmax, newsim, center, reduce, update, epslon ---- c
c -------------------------------------------------------------------- c
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      external   funct
c
      integer    n
      real*8     xinit(maxh), dist, eps, fr
c
      integer    iter, xh, xs, xl, x0, xr, xe, xc, j
      real*8     f(maxh5), x(maxh5,maxh)
      real*8     epslon
      real*8     eps1, alpha, beta, gamma
c
      data       alpha/-1.0d0/, beta/0.5d0/, gamma/2.0d0/
c
      x0 = n + 2
      xr = n + 3
      xe = n + 4
      xc = n + 5
c
      call first(n, f, x, funct, xinit, dist)
c -------------------------------------------------------------------- c
      write(6,*)
      write(6,32)'    #    -log L     standard error  x(1)',
     &'        x(2)        x(3)        x(4)        x(5)'
   32 format(2a)
      iter = 0
c
c                                                ****   main loop   ****
1     continue
c
c                                           ****   min max search   ****
      call minmax(n, f, xh, xs, xl)
c
c                                            ****   epsilon check   ****
      eps1 = epslon(n, f)
      write(6,31) iter, f(xl), eps1,(x(xl,i), i=1, n)
   31 format(i5, f15.3, 7d12.4)
c
      if(iter .gt. 2 .and. eps1 .lt. eps) go to 2
c
c                                               ****   center set   ****
      call center(n, x, xh, x0)
c
c                                               ****   reflection   ****
      call newsim(n, f, x, funct, x0, xh, alpha, xr)
c
      if(f(xr) .le. f(xs)) then
c
        if(f(xr) .lt. f(xl)) then
c
c                                                ****   expansion   ****
          call newsim(n, f, x, funct, x0, xr, gamma, xe)
c
          if(f(xe) .lt. f(xr)) then
            call update(n, f, x, xe, xh)
          else
            call update(n, f, x, xr, xh)
            end if
c
        else
          call update(n, f, x, xr, xh)
          end if
c
      else
c
        if(f(xr) .lt. f(xh)) call update(n, f, x, xr, xh)
c
c                                              ****   contraction   ****
        call newsim(n, f, x, funct, x0, xh, beta, xc)
c
        if(f(xc) .lt. f(xh)) then
          call update(n, f, x, xc, xh)
c
        else
c
c                                                   ****   reduce   ****
          call reduce(n, f, x, funct, xl)
c
          end if
c
        end if
c
      iter = iter + 1
c
      if(iter .gt. 1000 ) go to 2
c
c                                            ****   epsilon check   ****
      go to 1
c
2     continue
c
      do 10 j = 1, n
        xinit(j) = x(xl, j)
10      continue
      fr = f(xl)
c
      close(7)
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine minmax(n, f, xh, xs, xl)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      integer    n, xh, xs, xl
      real*8     f(maxh5)
c
      integer    i
      real*8     fmin1, fmax1, fmax2
c
      if(f(1) .gt. f(2)) then
        fmax1 = f(1)
        xh = 1
        fmax2 = f(2)
        xs = 2
        fmin1 = f(2)
        xl = 2
      else
        fmax1 = f(2)
        xh = 2
        fmax2 = f(1)
        xs = 1
        fmin1 = f(1)
        xl = 1
        end if
c
      do 10 i = 3, n+1
c
        if(f(i) .gt. fmax1) then
          fmax2 = fmax1
          xs = xh
          fmax1 = f(i)
          xh = i
c
        else if(f(i) .gt. fmax2) then
          fmax2 = f(i)
          xs = i
          end if
c
        if(f(i) .lt. fmin1) then
          fmin1 = f(i)
          xl = i
          end if
c
10      continue
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine first(n, f, x, funct, xinit, dist)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      external   funct
c
      integer    n
      real*8     f(maxh5), x(maxh5,maxh), xinit(maxh), xx(maxh), dist
c
      integer    i, j
c
      do 10 i = 1, n + 1
c
        do 20 j = 1, n
          x(i,j) = xinit(j)
          xx(j) = x(i,j)
20        continue
c
        if(i .ne. 1 ) then
          x(i,i-1) = x(i,i-1) + dist
          xx(i-1) = x(i,i-1)
          end if
c
        call funct(n, xx, f(i))
c
10      continue
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine center(n, x, xh, x0)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      integer    n, xh, x0
      real*8     x(maxh5,maxh)
c
      integer    i, j
c
      do 10 j = 1, n
        x(x0,j) = 0.0d0
        do 20 i = 1, n+1
          if(i .ne. xh) x(x0,j) = x(x0,j) + x(i,j)
20        continue
        x(x0,j) = x(x0,j) / dfloat(n)
10      continue
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      function   epslon(n, f)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      integer    n
      real*8     f(maxh5)
c
      integer    i
      real*8     epslon, emean
c
      emean = 0.0d0
      do 10 i = 1, n+1
        emean = emean + f(i)
10      continue
      emean = emean / dfloat(n+1)
c
      epslon = 0.0d0
      do 20 i = 1, n+1
        epslon = epslon + (f(i) - emean) ** 2
20      continue
      epslon = dsqrt(epslon) / dfloat(n+1)
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine newsim(n, f, x, funct, x0, in, prm, out)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      external   funct
c
      integer    n, x0, in, out
      real*8     f(maxh5), x(maxh5,maxh), xx(maxh), prm
c
      integer    j
c
      do 10 j = 1, n
        x(out,j) = prm * x(in,j) + (1.0 - prm) * x(x0,j)
        xx(j) = x(out,j)
10      continue
      call funct(n, xx, f(out))
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine update(n, f, x, in, out)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      integer    n, in, out
      real*8     f(maxh5), x(maxh5,maxh)
c
      integer    j
c
      do 10 j = 1 , n
        x(out,j) = x(in,j)
10      continue
c
      f(out) = f(in)
c
      return
      end
c -------------------------------------------------------------------- c
c -------------------------------------------------------------------- c
      subroutine reduce(n, f, x, funct, xl)
c
      parameter   (maxh=6, maxh5=maxh+5)
c
      external   funct
c
      integer    n, xl
      real*8     f(maxh5), x(maxh5,maxh), xx(maxh)
c
      integer    i, j
c
      do 10 i = 1, n+1
        if(i .ne. xl) then
          do 20 j = 1, n
            x(i,j) = (x(i,j) + x(xl,j)) / 2.0d0
            xx(j) = x(i,j)
20          continue
c
          call funct(n, xx, f(i))
          end if
10      continue
c
      return
      end
