      implicit real*8 (a-h, o-z)
      common ix,iy,iz
      dimension  x(1000), y(1000)
      dimension  xcl(1000,5000), ycl(1000,5000)
c
      pi=3.14159265358979d0
c
      open(10, FILE='TypeA-offspring.xy')
      open(11, FILE='TypeA-parents.xy')
      open(12,file='TypeA.param')
      read(12,*) ix,iy,iz
      read(12,*) ty
      read(12,*) amu,anu,a,sig1,sig2
c
      call Pois(amu,npts)
c
      do 15 i=1, npts
        x(i)=random(ix,iy,iz)
        y(i)=random(ix,iy,iz)*ty               
        write(11,*) x(i), y(i)    
 15     continue
        write(6,*) '#(parents)=', npts
c
      do 25 i=1, npts
          call  Pois(anu,ncl)
          write(6,*) '#(offspring)=', i, ncl
c
          do 35 j=1, ncl
 	    r=sqrt(-2*log(random(ix,iy,iz)))
	    theta=2*pi*(random(ix,iy,iz))	
            np=np+1
	    xclij=x(i)+r*cos(theta)*sig1     
	    yclij=y(i)+r*sin(theta)*sig1
	    xclij2=x(i)+r*cos(theta)*sig2     
	    yclij2=y(i)+r*sin(theta)*sig2
            jx=int(xclij)  
            jy=yclij/ty
            jx2=int(xclij2)  
            jy2=yclij2/ty
             if (xclij.le.0) then
               xclij=xclij+(1-jx)
             end if
             if (xclij2.le.0) then
               xclij2=xclij2+(1-jx2)
             end if
             if (yclij.le.0) then
               yclij=yclij+(1-jy)*ty
             end if
             if (yclij2.le.0) then
               yclij2=yclij2+(1-jy2)*ty
             end if
             if (xclij.ge.1) then
               xclij=xclij-jx
             end if 
             if (xclij2.ge.1) then
               xclij2=xclij2-jx2
             end if 
             if (yclij.ge.ty) then
               yclij=yclij-jy*ty
             end if
             if (yclij2.ge.ty) then
               yclij2=yclij2-jy2*ty
             end if
          choice=random(ix,iy,iz)               
          if(choice.le.a) then
            xcl(i,j)=xclij
            ycl(i,j)=yclij
          else
            xcl(i,j)=xclij2
            ycl(i,j)=yclij2
          endif
          write(10,*) xcl(i,j), ycl(i,j)
 35   continue
 11   format(' ',2F10.6)
 25   continue
        write(6,*) '#(total offspring)=', np
      close(10)
      close(11)
      close(12)
c
      stop
c
      end
********************************************************************************
*      *** Poisson random number ***      
       subroutine Pois(ram,m)
       implicit real*8(a-h,o-z)
       common ix,iy,iz
c      Poisson random number: m-1   
       alogu=ram
       m=0
 10    u=random(ix,iy,iz)       
       alogu=alogu+log(u)
       if (alogu.gt.0) then
           m=m+1
           go to 10
       end if
c
       return
c
       end
c
********************************************************************************************
      real function random*8(ix,iy,iz)
c     WICHMANN+HILL Appl.Statist.(JRSSC) (31) 188-(1982)
      IMPLICIT REAL*8(A-H,O-Z)
      ix=171*mod(ix,177)-2*(ix/177)
      iy=172*mod(iy,176)-35*(iy/176)
      iz=170*mod(iz,178)-63*(iz/178)
      if(ix.lt.0)  ix=ix+30269
      if(iy.lt.0)  iy=iy+30307
      if(iz.lt.0)  iz=iz+30323
      random=mod(float(ix)/30269.0+float(iy)/30307.0
     &                            +1-float(iz)/30323.0,1.0)
      crandom=float(ix)/30269.0+float(iy)/30307.0+1-float(iz)/30323.0
      return
      end	
