      implicit real*8 (a-h, o-z)
      common ix,iy,iz
      dimension  x1(1000), y1(1000)
      dimension  x2(1000), y2(1000)
      dimension  xcl1(1000,5000), ycl1(1000,5000)
      dimension  xcl2(1000,5000), ycl2(1000,5000)
      dimension xx1(15000),yy1(15000)
      dimension xx2(15000),yy2(15000)
c
      pi=3.14159265358979d0
c
      open(10, FILE='TypeB-offspring.xy')
      open(11,FILE='TypeB-parents.xy')
      open(12,file='TypeB.param')
      read(12,*) ix,iy,iz
      read(12,*) ty
      read(12,*) amu1,amu2,anu1,s1,s2

c
      write(6,*) 'a =', amu1/(amu1+amu2)
c
      call  Pois(amu1,m1)
c
      do 25 i=1, m1
        x1(i)=random(ix,iy,iz)
        y1(i)=random(ix,iy,iz)*ty               
        write(11,*) x1(i), y1(i)    
 25   continue
        write(6,*) '#(parents)=', m1
c
      np1=0
      np=0
      do 40 i=1, m1
          call  Pois(anu1,ncl1)
          write(6,*) '#(offspring)=', i, ncl1
        do 45 j=1, ncl1
          r1=sqrt(-2*log(random(ix,iy,iz)))
          theta1=2*pi*(random(ix,iy,iz))
          np1=np1+1
          np=np+1
          xcl1(i,j)=x1(i)+r1*cos(theta1)*s1    
	  ycl1(i,j)=y1(i)+r1*sin(theta1)*s1
          jx1=INT(xcl1(i,j))  
          jy1=ycl1(i,j)/ty
c
          if (xcl1(i,j).le.0) then
             xcl1(i,j)=xcl1(i,j)+(1-jx1)
          end if
c
          if (ycl1(i,j).le.0) then
             ycl1(i,j)=ycl1(i,j)+(1-jy1)*ty
          end if
c
          if (xcl1(i,j).ge.1) then
             xcl1(i,j)=xcl1(i,j)-jx1
          end if 
c
          if (ycl1(i,j).ge.ty) then
             ycl1(i,j)=ycl1(i,j)-jy1*ty
          end if
c
           xcl1ij = xcl1(i,j)
           ycl1ij = ycl1(i,j)
           xx1(np1)=xcl1ij
           yy1(np1)=ycl1ij
          write(10,*) xx1(np1), yy1(np1)
 45       continue
 40     continue
c----------------------------------------------------------------------
      call  Pois(amu2,m2)
        do 35 i=1, m2
          x2(i)=random(ix,iy,iz)
          y2(i)=random(ix,iy,iz)*ty               
          write(11,*) x2(i), y2(i)    
 35     continue
        write(6,*) '#(parents)=', m2
c
        np2=0
        do 50 i=1, m2
          call  Pois(anu1,ncl2)
          write(6,*) '#(offspring)=', i, ncl2
          do 55 j=1, ncl2
 	    r2=sqrt(-2*log(random(ix,iy,iz)))
	    theta2=2*pi*(random(ix,iy,iz))
            np2=np2+1	
            np=np+1	
	    xcl2(i,j)=x2(i)+r2*cos(theta2)*s2     
	    ycl2(i,j)=y2(i)+r2*sin(theta2)*s2
            jx2=int(xcl2(i,j))  
            jy2=ycl2(i,j)/ty
               if (xcl2(i,j).le.0) then
               xcl2(i,j)=xcl2(i,j)+(1-jx2)
               end if
               if (ycl2(i,j).le.0) then
               ycl2(i,j)=ycl2(i,j)+(1-jy2)*ty
               end if
               if (xcl2(i,j).ge.1) then
               xcl2(i,j)=xcl2(i,j)-jx2
               end if 
               if (ycl2(i,j).ge.ty) then
               ycl2(i,j)=ycl2(i,j)-jy2*ty
               end if
           xcl2ij = xcl2(i,j)
           ycl2ij = ycl2(i,j)
           xx2(np2)=xcl2ij
           yy2(np2)=ycl2ij
          write(10,*) xx2(np2), yy2(np2)
 55       continue
 50     continue
        write(6,*) '#(total offspring)=', np1,np2,np
C
        close(10)
        close(11)
        close(12)
c
	stop
c
	end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*      *** Poisson random number ***      
       subroutine Pois(ram,m)
       implicit real*8(a-h,o-z)
       common ix,iy,iz
c      Poisson random number: m-1   
       alogu=ram
       m=0
 10    u=random(ix,iy,iz)       
       alogu=alogu+log(u)
       if (alogu.gt.0) then
           m=m+1
           go to 10
       end if
c
       return
c
       end
c
********************************************************************************************
      real function random*8(ix,iy,iz)
c     WICHMANN+HILL Appl.Statist.(JRSSC) (31) 188-(1982)
      implicit real*8(a-h,o-z)
      ix=171*mod(ix,177)-2*(ix/177)
      iy=172*mod(iy,176)-35*(iy/176)
      iz=170*mod(iz,178)-63*(iz/178)
      if(ix.lt.0)  ix=ix+30269
      if(iy.lt.0)  iy=iy+30307
      if(iz.lt.0)  iz=iz+30323
      random=mod(float(ix)/30269.0+float(iy)/30307.0
     &                            +1-float(iz)/30323.0,1.0)
      crandom=float(ix)/30269.0+float(iy)/30307.0+1-float(iz)/30323.0
      return
      end	
